<?php
/**
* @version 			SEBLOD 2.x Core ~ $Id: index.php alexandre_lapoux $
* @package			SEBLOD (App Builder & CCK) // SEBLOD Seb_nivo_slider (Form Builder)
* @url				http://www.seblod.com
* @editor			Octopoos - www.octopoos.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
**/

// No Direct Access
defined( '_JEXEC' ) or die;

// -- Initialize
require_once dirname(__FILE__).DIRECTORY_SEPARATOR.'config.php';
$cck	=	CCK_Rendering::getInstance( $this->template );
if ( $cck->initialize() === false ) { return; }
$doc						=	JFactory::getDocument();
$items_number				=	0;
$id 						= 	$cck->id;	
$items						=	$cck->getItems();
$item_margin		 		=	$cck->getStyleParam( 'item_margin', '8' );
$js_params					=	'';
$prems						=	0;

// Params init Nivo Slider
$set['style']	 			= 'default';

$settings 					= array(
'effect' 					=>	'"'.$cck->getStyleParam('effect', 'fade').'"',
'slices' 					=>	(int)$cck->getStyleParam('slices', '15'),
'boxCols' 					=>	(int)$cck->getStyleParam('boxCols', '8'),
'boxRows' 					=>	(int)$cck->getStyleParam('boxRows', '4'),
'animSpeed' 				=>	(int)$cck->getStyleParam('animSpeed', '500'),
'pauseTime' 				=>	(int)$cck->getStyleParam('pauseTime', '3000'),
'startSlide' 				=>	(int)$cck->getStyleParam('startSlide', '0'),
'directionNav' 				=>	$cck->getStyleParam('directionNav', 'true'),
'controlNav' 				=>	$cck->getStyleParam('controlNav', 'true'),
'controlNavThumbs' 			=>	$cck->getStyleParam('controlNavThumbs', 'false'),
'pauseOnHover' 				=>	$cck->getStyleParam('pauseOnHover', 'true'),
'manualAdvance' 			=>	$cck->getStyleParam('manualAdvance', 'false'),
'prevText' 					=>	'"'.$cck->getStyleParam('prevText', '').'"',
'nextText' 					=>	'"'.$cck->getStyleParam('nextText', '').'"',
'randomStart' 				=>	$cck->getStyleParam('randomStart', 'false') 
);

$acceptedTags =	$cck->getStyleParam('accepted_tags','');
$acceptedTags	=	explode(',', $acceptedTags);
array_walk($acceptedTags, function(&$value){$value = !empty($value) ? '<'.$value.'>': $value;});
$acceptedTags	=	implode(',', $acceptedTags);

$image_fields	=	$cck->getFields( 'image', '', false );

if(!count($image_fields))
	return '';

//si je suis sous warp, je checke si je suis sur mobile ou non
$ismobile=false;
$templateDir = JPATH_THEMES.DIRECTORY_SEPARATOR.JFactory::getApplication()->getTemplate().DIRECTORY_SEPARATOR;
$filename_conf=$templateDir."config.php";
if (file_exists($filename_conf)) {
	require_once($filename_conf);
	if (isset($warp['browser']))	$ismobile=$warp['browser']->isMobile();
}

// Assets JS
if(!$ismobile){
	foreach( $settings as $cle=>$valeur ) {
		$js_params .= ( !$prems ) ? $cle." : ".$valeur : ",".$cle." : ".$valeur; 
		$prems	=	1;
	}
// 	$js	 =	'jQuery(window).load(function() {jQuery("#'.$id.'_ns").nivoSlider({'.$js_params.'}); });';
	$js	 =	'jQuery(window).load(function() {jQuery("#'.$id.'_tmpImg").hide();jQuery("#'.$id.'_ns").nivoSlider({'.$js_params.'}); });';
		
	$css='	.nivo-html-caption {
		display:none;
	}';
		
	// Add JS file
	CCK::loadjQuery();
	$doc->addScript( JURI::root( true ).'/templates/'.$this->template.'/js/jquery.nivo.slider.modified.js' );

}else{
	$css='.theme-default .nivo-html-caption a{width:100%;display:block;} .theme-default .nivo-html-caption{margin-bottom:15px;}';
}

$doc->addStyleDeclaration($css);

// Add CSS file
$doc->addStyleSheet( JURI::root( true ).'/templates/'.$this->template.'/css/nivo-slider.css' );
$doc->addStyleSheet( JURI::root( true ).'/templates/'.$this->template.'/css/style.css' );
$doc->addStyleSheet( JURI::root( true ).'/templates/'.$this->template.'/css/default.css' );

// Set template;
$all_fields		=	'';
$all_img		=	'';
$idCaption		=	'';
$count			=	count( $items );
$content_type	=	$cck->type;
$myFunction = 'strip_tags';
$title = 'art_title';

// Set items

$positions = $cck->getPositions();
unset($positions['image']);
$positions = array_keys($positions);
$firstImg = null;
$firstFields = null;

/* @var $item CCK_Item */
foreach( $items as $item ) {
	$idCaption = $item->pk;
	$fields = $item->getFields('image');
	$imgFound = false;
	foreach ( $fields as $field ) {
		if($field->type != 'upload_image')
			continue;
		
		if(!isset($field->typo_options) || $field->typo_options === '' ){
			throw new Exception('You have to specify a typo option on the field '.$field->name);
		}
		//get typo en cours
		$options=json_decode($field->typo_options);		
		$typo=$options->thumb;
		if(empty($typo)){
			continue;
		}
		$fimage=$field->$typo;
		if(empty($fimage)){
			// if empty image, continue
			continue;                                                                                                          
		}
// 		var_dump($field);
// 		echo $field->html;die();
		$fimage = substr($fimage,0,1) === '/' ? $fimage : '/'.$fimage;
		
		$image="<img src='$fimage' data-thumb='$fimage' alt='{$field->image_alt}' title='#htmlcaption_".$idCaption."_-_{$field->image_title}' />";
		if(!empty($field->link))	$image="<a href='{$field->link}' title='{$field->image_title}'>$image</a>";
		$firstImg = is_null($firstImg) ? $image : $firstImg;
		
		$all_img .= $image;
		$imgFound = true;
		break;
	}
	if(!$imgFound)
		continue;		

	$tmp_all_fields = '<div id="htmlcaption_'.$idCaption.'" class="nivo-html-caption ">';
	
	foreach($positions as $position){
		if ( $n = $cck->countFields( $position ) ) {
			$style = $position === 'hidden' ? 'display:none;' : '';
			$tmpPos = '<div class="'.$position.'_pulsar_nivoslider_responsive" style="'.$style.'">';
			$tmpPos .= '<span >'.$cck->getPosition($position)->legend.'</span>';
			$fields = $item->getFields($position);
			$tmp_fields_pos = '';
			foreach($fields as $field){
	// 			$name	=	$field->name;
	// 			$label		=	$item->getLabel( $name );
	// 			$label		=	$label ? $label.' : ' : '';
	// 			$content	.=	'<div class="cck-clrfix'.$item->getMarkup_Class( $name ).'">'.$label.$item->renderField( $name ).'</div>';

				$tmp = $myFunction($item->renderField( $field->name),$acceptedTags);
				$tmp_field = !empty($tmp) ? '<div class="cck-clrfix'.$item->getMarkup_Class( $field->name ).'">' . $tmp . '</div>' : ''; 
				$tmp_fields_pos .=	$tmp_field;
				
// 				$tmp_all_fields .= $tmp_all_fields ? $myFunction($item->renderField( $field->name),$acceptedTags) : '<div id="htmlcaption_'.$idCaption.'" class="nivo-html-caption ">'. $myFunction( $item->renderField( $field->name ),$acceptedTags);
			}
			if(!empty($tmp_fields_pos)){
				$tmpPos .=	$tmp_fields_pos . '</div>';
				$firstFields = is_null($firstFields) ? $tmpPos : $firstFields;
				$tmp_all_fields .= $tmpPos;
			}
		}
	}
	$tmp_all_fields .= '</div>';
	
	$all_fields .= $tmp_all_fields;
}

$pattern = '#class([ \t]*)=([ \t]*)("|\')#';
if(preg_match($pattern, $firstImg)){
	$pattern = '#class(?:[ \t]*)=(?:[ \t]*)(?:"|\')(.*)(?:"|\')#';
	$t = preg_replace($pattern, "class = '$1 nivo-main-image '", $firstImg);
}else{
	$firstImg = str_replace('/>', ' class="nivo-main-image" />', $firstImg);
}

?>

<div id="<?php echo $id; ?>" class="<?php echo $cck->id_class ?> slider-wrapper theme-<?php echo $set['style']; ?>">
	<div id="<?php echo $id.'_tmpImg';?>" class="tmpImg slider_fisrtImg">
	<?php echo $firstImg;?>
	</div>
	<div id="<?php echo $id.'_ns'; ?>" class="nivoSlider">
    	<?php if(!$ismobile) echo $all_img; ?>
    </div>	
    <?php echo $all_fields; ?>
</div>

<?php
// Assets JS to the end (important)
if(!$ismobile) $cck->addScriptDeclaration( $js );
$cck->finalize();

?>


